/* program: cmCR.c */

#include <stdio.h>
#include <stdlib.h>
#ifndef _WIN32
#include "cmat.h"
#endif
#include "integer.h"
#include "fun.h"
#include "primes.h"

MPCR *CR[M0];
POLYCR PCR[M0];
MPMATCR *CRM[M0];
MPMATPCR *PCRM[M0];
extern long int nettbytes;

unsigned int VERSION=2;
char cCR[20], cPCR[20], cCRM[20], cPCRM[20];

int main()
{
#ifndef _WIN32
	readrc();
#endif
	INITMPIBANK();
#ifdef _WIN32
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("\t\t\tCMATCR: VERSION 2.1: 4th July 2010\n");
	printf("\n\n");
	printf("\tAuthor:Dr.K.R. MATTHEWS\n\n\n\n");
	printf("\tBRISBANE, AUSTRALIA\n\n\n\n");
	printf("\thttp://www.numbertheory.org/keith.html\n\n\n\n");
	printf("\n\n\n\n");
	GetReturn();
#endif
	menuinit("menuCR.dat");
	CAL_CR();
	menuend();
	exit (0);
}

void STARTUP_CR()
{
	unsigned int i;
	FILE *fp;

	  strcpy(cCR,"cCR");
	  strcpy(cPCR,"cPCR");
	  strcpy(cCRM,"cCRM");
	  strcpy(cPCRM,"cPCRM");
	if ((fp = fopen(cCR, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			CR[i] = ZEROCR();
		FPRINT_CR(cCR);
	}
	else
		fclose(fp);	
	if ((fp = fopen(cPCR, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			PCR[i] = NULL;
		FPRINT_PCR(cPCR);
	}
	else
		fclose(fp);	
	if ((fp = fopen(cCRM, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			CRM[i] = ZEROMNCR(1, 1);
		FPRINTMAT_CR(cCRM);
	}
	else
		fclose(fp);	
	if ((fp = fopen(cPCRM, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			PCRM[i] = ZEROMNPCR(1, 1);
		FPRINTMAT_PCR(cPCRM);
	}
	else
		fclose(fp);	
	FINPUT_CR(cCR);
	FINPUT_PCR(cPCR);
	FINPUTMAT_CR(cCRM, 0);
	FINPUTMAT_PCR(cPCRM);
}

void FINISH_CR()
{
	unsigned int i;

	for (i = 0; i < M0; i++)
	{
		FREEMPCR(CR[i]);
		FREEMATCR(CRM[i]);
		FREEMATPCR(PCRM[i]);
                DELETE_PCR(PCR[i]);
	}
	FREEMPIBANK();
#ifdef DEBUG
	printf("after cmatCR nettbytes = %ld\n", nettbytes);
#endif
	GetReturn();
	return;
}

void CAL_CR()
{
	int GoOnFlag = 1, GoOnFlag1, answer;
	char c, cmd[50];

	STARTUP_CR();
	while (GoOnFlag)
	{
		c = drawmenu(1);
		switch (c)
		{
		case 'i':
				clearscreen();
#ifdef _WIN32
				sprintf(cmd, "type info.dat | more");
				system(cmd);
#else
				sprintf(cmd, "%s %s/info.dat",PAGER,DATPATH);
				system(cmd);
#endif
			break;
		case 'x':
			INPUTCR_();
			break;
		case 'L':
			LPRINTCR_();
			break;
		case 'c':
			GoOnFlag1 = 1;
			while (GoOnFlag1)
			{
				c = drawmenu(2);
				switch (c)
				{
				case 'n':
					NumberCalcCR();
					break;
				case 'p':
					PolyCalcCR();
					break;
				case 'm':
					MatCalcCR();
					break;
				case 'q':
					GoOnFlag1 = 0;
					break;
				}
			}
			break;
		case 'p':
			PRINTCR_();
			break;
		case 'q':
			clearscreen();
			  printf("y : save calculations\n");
			  printf("n :  do not save calculations\n\n");
			  answer = GetYN();
			  clearscreen();
			  if (answer)
			  {
				FPRINT_CR(cCR);
				FPRINTMAT_CR(cCRM);
				FPRINT_PCR(cPCR);
				FPRINTMAT_PCR(cPCRM);
			  }
			  else
			  {
				remove(cCR);
				remove(cCRM);
				remove(cPCR);
				remove(cPCRM);
			  }
			printf("Exiting complex rational calculator\n");
			FINISH_CR();
			GoOnFlag = 0;
			break;
		}
	}
}

void NumberCalcCR()
{
	char c;
	int GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(3);
		switch (c)
		{
		case 'c':
			CONJ_CR();
			break;
		case 'a':
			ADD_CR();
			break;
		case 's':
			SUB_CR();
			break;
		case 't':
			MULT_CR();
			break;
		case 'e':
			POWER_CR();
			break;
		case 'r':
			RATIO_CR();
			break;
		case 'i':
			INVERSE_CR();
			break;
		case 'x':
			INPUT_CR();
			break;
		case 'p':
			PRINT_CR();
			break;
		case 'q':
			GoOnFlag = 0;
			FPRINT_CR(cCR);
			break;
		}
	}
}

void PolyCalcCR()
{
	char c;
	int GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(4);
		switch (c)
		{
		case 'a':
			ADD_PCR();
			break;
		case 's':
			SUB_PCR();
			break;
		case 't':
			MULT_PCR();
			break;
		case 'e':
			POWER_PCR();
			break;
		case 'v':
			VAL_PCR();
			break;
		case 'd':
			DERIV_PCR();
			break;
		case 'f':
			SCALAR_PCR();
			break;
		case 'r':
			DIV_PCR();
			break;
		case 'i':
			MOD_PCR();
			break;
		case 'g':
			GCD_PCR();
			break;
		case 'G':
			EUCLID_PCR();
			break;
		case 'L':
			EUCLIDS_PCR();
			break;
		case 'z':
				FactorCalcCR();
				break;
		case 'x':
			INPUTCR_();
			break;
		case 'p':
			PRINT_PCR();
			break;
		case 'q':
			GoOnFlag = 0;
			FPRINT_PCR(cPCR);
			break;
		}
	}
}

void MatCalcCR()
{
	char c;
	int GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(5);
		switch (c)
		{
		case 'm':
			MATRIX_ARITH_CR();
			break;
		case 'j':
			JOINMAT_CR();	
			break;
		case 'o':
			OPS_CR();
			break;
		case 'v':
			ExtractCR_();
			break;
		case 'c':
			MATALG_CR();
			break;
		case 'f':
			DOT_CR();
			break;
		case 's':
			MATRIX_ARITH_PCR();
			break;
		case 'p':
			PRINTCR_();
			break;
		case 'L':
			LPRINTCR_();
			break;
		case 'x':
			INPUTCR_();
			break;
		case 'q':
			GoOnFlag = 0;
			break;
		}
	}
}

void FactorCalcCR()
{
	int GoOnFlag = 1;
	char c;

	while (GoOnFlag)
	{
		c = drawmenu(6);
		switch (c)
		{
			case 'z':
				SQUAREFREE_PCR();
				break;
			case 'w':
				BTRAGER_PCR();
				break;
			case 'x':
				INPUTCR_();
				break;
			case 'p':
				PRINT_PCR();
				break;
			case 'q':
				GoOnFlag = 0;
				FPRINT_PCR(cPCR);
				break;
		}
	}
}
