/* cm_CR.c */
/* complex number routines used in cmCR.c.*/

#include <stdio.h>
#include "integer.h"
#include "fun.h"

extern MPCR *CR[];

void ADD_CR()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("CR[%u] = ", j);
	PRINTCR(CR[j]);
	printf(" + CR[%u] = ", k);
	PRINTCR(CR[k]);
	FREEMPCR(CR[l]);
	CR[l] = ADDCR(CR[j], CR[k]);
	printf(" -> CR[%u] = ", l);
	PRINTCR(CR[l]);
	printf("\n");
	GetReturn();
	return;
}

void CONJ_CR()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	printf("The complex conjugate of CR[%u] = ", j);
	PRINTCR(CR[j]);
	FREEMPCR(CR[k]);
	CR[k] = CONJCR(CR[j]);
	printf(" -> CR[%d] = ", k);
	PRINTCR(CR[k]);
	printf("\n");
	GetReturn();
	return;
}

void SUB_CR()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("CR[%u] = ", j);
	PRINTCR(CR[j]);
	printf(" - CR[%u] = ", k);
	PRINTCR(CR[k]);
	FREEMPCR(CR[l]);
	CR[l] = SUBCR(CR[j], CR[k]);
	printf(" -> CR[%u] = ", l);
	PRINTCR(CR[l]);
	printf("\n");
	GetReturn();
	return;
}

void MULT_CR()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("CR[%u] = ", j);
	PRINTCR(CR[j]);
	printf(" * CR[%u] = ", k);
	PRINTCR(CR[k]);
	FREEMPCR(CR[l]);
	CR[l] = MULTCR(CR[j], CR[k]);
	printf(" -> CR[%u] = ", l);
	PRINTCR(CR[l]);
	printf("\n");
	GetReturn();
	return;
}

void POWER_CR()
{
	unsigned int n, j, k;

	if (scanf12(&n, &j, &k) == 0)
		return;
	printf("The %u-th power of CR[%u] = ", n, j);
	PRINTCR(CR[j]);
	FREEMPCR(CR[k]);
	CR[k] = POWERCR(CR[j], n);
	printf(" -> CR[%u] = ", k);
	PRINTCR(CR[k]);
	printf("\n");
	GetReturn();
	return;
}

void RATIO_CR()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (EQZEROCR(CR[k]))
		printf("CR[%u] = 0 and so CR[%u]/CR[%u] does not exist!\n", k, j, k);
	else
	{
		printf("CR[%u] = ", j);
		PRINTCR(CR[j]);
		printf(" / CR[%u] = ", k);
		PRINTCR(CR[k]);
		FREEMPCR(CR[l]);
		CR[l] = RATIOCR(CR[j], CR[k]);
		printf(" -> CR[%u] = ", l);
		PRINTCR(CR[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void INVERSE_CR()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	if (EQZEROCR(CR[j]))
		printf("CR[%u] = 0 and has no inverse\n", j);
	else
	{
		printf("The inverse of CR[%u] = ", j);
		PRINTCR(CR[j]);
		FREEMPCR(CR[k]);
		CR[k] = INVERSECR(CR[j]);
		printf(" -> CR[%u] = ", k);
		PRINTCR(CR[k]);
		printf("\n");
	}
	GetReturn();
	return;
}
