/* cm_PCRM1.c */

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"

extern MPCR *CR[];
extern POLYCR PCR[];
extern MPMATCR *CRM[];
extern MPMATPCR *PCRM[];

extern char cCR[];
extern char cCRM[];
extern char cPCRM[];
extern char cPCR[];

void SWAP_ROWSPCR_()
{
	unsigned int j, k, p, q;
	MPMATPCR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > PCRM[j]->R)
		printf("p < 1 or > number of rows of PCRM[%u]\n", j);
	else if (q < 1 || q > PCRM[j]->R)
		printf("q < 1 or > number of rows of PCRM[%u]\n", j);
	else
	{
		printf("PCRM[%u] = \n", j);
		PRINTMATPCR(0, PCRM[j]->R - 1, 0, PCRM[j]->C - 1, PCRM[j]);
		printf("->\n");
		Temp = PCRM[k];
		PCRM[k] = SWAP_ROWSPCR(p - 1, q - 1, PCRM[j]);
		FREEMATPCR(Temp);
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
	}
	GetReturn();
	return;
}

void SWAP_COLSPCR_()
{
	unsigned int j, k, p, q;
	MPMATPCR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > PCRM[j]->C)
		printf("p < 1 or > number of columns of PCRM[%u]\n", j);
	else if (q < 1 || q > PCRM[j]->C)
		printf("q < 1 or > number of columns of PCRM[%u]\n", j);
	else
	{
		printf("PCRM[%u] = \n", j);
		PRINTMATPCR(0, PCRM[j]->R - 1, 0, PCRM[j]->C - 1, PCRM[j]);
		printf("->\n");
		Temp = PCRM[k];
		PCRM[k] = SWAP_COLSPCR(p - 1, q - 1, PCRM[j]);
		FREEMATPCR(Temp);
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
	}
	GetReturn();
	return;
}

void SCALAR_ROWPCR_()
{
	unsigned int j, k, l, p;
	MPMATPCR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > PCRM[k]->R)
		printf("p < 1 or > number of rows of PCRM[%u]\n", k);
	else
	{
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
		printf("->\n");
		Temp = PCRM[l];
		PCRM[l] = SCALAR_ROWPCR(p - 1, CR[j], PCRM[k]);
		FREEMATPCR(Temp);
		printf("PCRM[%u] = \n", l);
		PRINTMATPCR(0, PCRM[l]->R - 1, 0, PCRM[l]->C - 1, PCRM[l]);
	}
	GetReturn();
	return;
}

void SCALAR_COLPCR_()
{
	unsigned int j, k, l, p;
	MPMATPCR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > PCRM[k]->C)
		printf("p < 1 or > number of columns of PCRM[%u]\n", k);
	else
	{
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
		printf("->\n");
		Temp = PCRM[l];
		PCRM[l] = SCALAR_COLPCR(p - 1, CR[j], PCRM[k]);
		FREEMATPCR(Temp);
		printf("PCRM[%u] = \n", l);
		PRINTMATPCR(0, PCRM[l]->R - 1, 0, PCRM[l]->C - 1, PCRM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_ROWPCR_()
{
	unsigned int j, k, l, p, q;
	MPMATPCR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > PCRM[k]->R)
		printf("q < 1 or > number of rows of PCRM[%u]\n", k);
	else if (p < 1 || p > PCRM[k]->R)
		printf("p < 1 or > number of rows of PCRM[%u]\n", k);
	else
	{
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
		printf("->\n");
		Temp = PCRM[l];
		PCRM[l] = ADD_MULT_ROWPCR(p - 1, q - 1, PCR[j], PCRM[k]);
		FREEMATPCR(Temp);
		printf("PCRM[%u] = \n", l);
		PRINTMATPCR(0, PCRM[l]->R - 1, 0, PCRM[l]->C - 1, PCRM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_COLPCR_()
{
	unsigned int j, k, l, p, q;
	MPMATPCR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > PCRM[k]->C)
		printf("q < 1 or > number of columns of PCRM[%u]\n", k);
	else if (p < 1 || p > PCRM[k]->C)
		printf("p < 1 or > number of columns of PCRM[%u]\n", k);
	else
	{
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
		printf("->\n");
		Temp = PCRM[l];
		PCRM[l] = ADD_MULT_COLPCR(p - 1, q - 1, PCR[j], PCRM[k]);
		FREEMATPCR(Temp);
		printf("PCRM[%u] = \n", l);
		PRINTMATPCR(0, PCRM[l]->R - 1, 0, PCRM[l]->C - 1, PCRM[l]);
	}
	GetReturn();
	return;
}

void OPS_PCR()
{
	int GoOnFlag = 1;
        char c;

	while (GoOnFlag)
	{
		c = drawmenu(13);
		switch (c)
		{
		case 'i':
			SWAP_ROWSPCR_();
			break;
		case 'j':
			SWAP_COLSPCR_();
			break;
		case 'm':
			SCALAR_ROWPCR_();
			break;
		case 'n':
			SCALAR_COLPCR_();
			break;
		case 'a':
			ADD_MULT_ROWPCR_();
			break;
		case 'b':
			ADD_MULT_COLPCR_();
			break;
		case 'x':
			INPUTCR_();
			break;
		case 'q':
			FPRINT_PCR(cPCR);
			FPRINTMAT_PCR(cPCRM);
			GoOnFlag = 0;
			break;
		}
	} 
}

void IDENTITY_PCR()
{
	unsigned int m, j;

	if (scanf11(&m, &j) == 0)
		return;
	if (m == 0)
		printf("m == 0\n");
	else
	{
		FREEMATPCR(PCRM[j]);
		PCRM[j] = IDENTITYPCR(m);
		printf("PCRM[%u] = \n\n", j);
		PRINTMATPCR(0, PCRM[j]->R - 1, 0, PCRM[j]->C - 1, PCRM[j]); 
	}
	GetReturn();
	return;
}

void DIAG_PCR()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	if (CRM[j]->R != CRM[j]->C)
		printf("Matrix CRM[%u] is not square\n", j);
	else
	{
		printf("xI[%u]\n", CRM[j]->R);
		printf("- CRM[%u] = \n", j);
		PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
		FREEMATPCR(PCRM[k]);
		PCRM[k] = DIAGXPCR(CRM[j]);
		printf(" ->\n");
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
	}
	GetReturn();
	return;
}

void ADJ_PCR()
{
	unsigned int j, k;
	POLYCR A;
	MPMATPCR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	if (PCRM[j]->R != PCRM[j]->C)
		printf("Matrix PCRM[%u] is not square\n", j);
	else if (PCRM[j]->R == 1)
		printf("PCRM[%u] is 1 x 1\n", j);
	else
	{
		printf("adj of PCRM[%u] = \n", j);
		PRINTMATPCR(0, PCRM[j]->R - 1, 0, PCRM[j]->C - 1, PCRM[j]);
		Temp = PCRM[k];
		A = LEVERRIER_PCR(PCRM[j], &PCRM[k]);
		DELETE_PCR(A);
		FREEMATPCR(Temp);
		printf("->\n");
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
	}
	GetReturn();
	return;
}

void DET_PCR()
{
	unsigned int j, k;
	MPMATPCR *adj;

	if (scanf02(&j, &k) == 0)
		return;
	if (PCRM[j]->R != PCRM[j]->C)
		printf("Matrix PCRM[%u] is not square\n", j);
	else if (PCRM[j]->R == 1)
		printf("PCRM[%u] is 1 x 1\n", j);
	else
	{
		printf("det of PCRM[%u] = \n", j);
		PRINTMATPCR(0, PCRM[j]->R - 1, 0, PCRM[j]->C - 1, PCRM[j]);
		DELETE_PCR(PCR[k]);
		PCR[k] = LEVERRIER_PCR(PCRM[j], &adj);
		FREEMATPCR(adj);
		printf("->\n");
		printf("PCR[%u] = ", k);
		PRINTPCR(PCR[k]);
		printf("\n");
	}
	GetReturn();
	return;
}

void SMITH_PCR()
{
	int z;
	unsigned int i, j, k, l, p, q, r;
	POLYCR *A;
	MPMATPCR *Temp1, *Temp2;

	if (scanf03(&j, &k, &l) == 0)
		return;
	ZEROTESTPCR(0, PCRM[j], &p, &q);
	if (p == PCRM[j]->R && q == PCRM[j]->C)
		printf("PCRM[%u] is a zeromatrix\n", j);
	else
	{
		printf("The invariant factors of PCRM[%u] = \n", j);
		PRINTMATPCR(0, PCRM[j]->R - 1, 0, PCRM[j]->C - 1, PCRM[j]);
		z = (PCRM[j]->R >= PCRM[j]->C) ? PCRM[j]->C : PCRM[j]->R;
		Temp1 = PCRM[l];
		Temp2 = PCRM[k];
		A = SMITHPCR(PCRM[j], &PCRM[k], &PCRM[l], &r);
		printf("are\n\n");
		for (i = 0; i < r; i++)
		{
			printf("invariant factor d[%u] = ", i);
			PRINTPCR(A[i]);
			printf("\n");
			DELETE_PCR(A[i]);
		}
		ffree((char *) A, z * sizeof(POLYCR));
		FREEMATPCR(Temp1);
		FREEMATPCR(Temp2);
		GetReturn();
		printf("PCRM[%u] = \n", k);
		PRINTMATPCR(0, PCRM[k]->R - 1, 0, PCRM[k]->C - 1, PCRM[k]);
		printf("\n");
		GetReturn();
		printf("PCRM[%u] = \n", l);
		PRINTMATPCR(0, PCRM[l]->R - 1, 0, PCRM[l]->C - 1, PCRM[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void SMITH1A_PCR()
{
	int z;
	unsigned int i, r, j, c = 0;
	POLYCR *A;
	MPMATPCR *M;

	if (scanf01(&j) == 0)
		return;
	printf("The invariant factors of CRM[%u] = \n", j);
	PRINTMATCR(0, CRM[j]->R - 1, 0, CRM[j]->C - 1, CRM[j]);
	M = DIAGXPCR(CRM[j]);
	z = (M->R >= M->C) ? M->C : M->R;
	A = SMITH1PCR(M, &r);
	FREEMATPCR(M);
	printf("are\n\n");
	for (i = 0; i <= r - 1; i++)
	{
		if (A[i]->DEG > 0)
		{
			c++;
			printf("invariant factor d[%u] = ", c);
			PRINTPCR(A[i]);
			printf("\n");
		}
		DELETE_PCR(A[i]);
	}
	ffree((char *) A, z * sizeof(POLYCR));
	GetReturn();
	return;
}

void MATRIX_ARITH_PCR()
{
	char c;
	int GoOnFlag;
	GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(12);
		switch (c)
		{
			case 'o':
				OPS_PCR();
				break;
			case 'i':
				IDENTITY_PCR();
				break;
			case 'e':
				DIAG_PCR();
				break;
			case 'a':
				ADJ_PCR();
				break;
			case 'd':
				DET_PCR();
				break;
			case 'f':
				SMITH_PCR();
				break;
			case 'F':
				SMITH1A_PCR();
				break;
			case 'x':
				INPUTCR_();
				break;
			case 'p':
				PRINTCR_();
				break;
			case 'q':
				GoOnFlag = 0;
				FPRINT_CR(cCR);
				FPRINTMAT_CR(cCRM);
				FPRINT_PCR(cPCR);
				FPRINTMAT_PCR(cPCRM);
				break;
		}
	} 
}
