/* cm_PRM1.c */

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"

extern MPR *R[];
extern POLYR PR[];
extern MPMATR *RM[];
extern MPMATPR *PRM[];

extern char cR[];
extern char cRM[];
extern char cPRM[];
extern char cPR[];

void SWAP_ROWSPR_()
{
	unsigned int j, k, p, q;
	MPMATPR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > PRM[j]->R)
		printf("p < 1 or > number of rows of PRM[%u]\n", j);
	else if (q < 1 || q > PRM[j]->R)
		printf("q < 1 or > number of rows of PRM[%u]\n", j);
	else
	{
		printf("PRM[%u] = \n", j);
		PRINTMATPR(0, PRM[j]->R - 1, 0, PRM[j]->C - 1, PRM[j]);
		printf("->\n");
		Temp = PRM[k];
		PRM[k] = SWAP_ROWSPR(p - 1, q - 1, PRM[j]);
		FREEMATPR(Temp);
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
	}
	GetReturn();
	return;
}

void SWAP_COLSPR_()
{
	unsigned int j, k, p, q;
	MPMATPR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > PRM[j]->C)
		printf("p < 1 or > number of columns of PRM[%u]\n", j);
	else if (q < 1 || q > PRM[j]->C)
		printf("q < 1 or > number of columns of PRM[%u]\n", j);
	else
	{
		printf("PRM[%u] = \n", j);
		PRINTMATPR(0, PRM[j]->R - 1, 0, PRM[j]->C - 1, PRM[j]);
		printf("->\n");
		Temp = PRM[k];
		PRM[k] = SWAP_COLSPR(p - 1, q - 1, PRM[j]);
		FREEMATPR(Temp);
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
	}
	GetReturn();
	return;
}

void SCALAR_ROWPR_()
{
	unsigned int j, k, l, p;
	MPMATPR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > PRM[k]->R)
		printf("p < 1 or > number of rows of PRM[%u]\n", k);
	else
	{
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
		printf("->\n");
		Temp = PRM[l];
		PRM[l] = SCALAR_ROWPR(p - 1, R[j], PRM[k]);
		FREEMATPR(Temp);
		printf("PRM[%u] = \n", l);
		PRINTMATPR(0, PRM[l]->R - 1, 0, PRM[l]->C - 1, PRM[l]);
	}
	GetReturn();
	return;
}

void SCALAR_COLPR_()
{
	unsigned int j, k, l, p;
	MPMATPR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > PRM[k]->C)
		printf("p < 1 or > number of columns of PRM[%u]\n", k);
	else
	{
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
		printf("->\n");
		Temp = PRM[l];
		PRM[l] = SCALAR_COLPR(p - 1, R[j], PRM[k]);
		FREEMATPR(Temp);
		printf("PRM[%u] = \n", l);
		PRINTMATPR(0, PRM[l]->R - 1, 0, PRM[l]->C - 1, PRM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_ROWPR_()
{
	unsigned int j, k, l, p, q;
	MPMATPR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > PRM[k]->R)
		printf("q < 1 or > number of rows of PRM[%u]\n", k);
	else if (p < 1 || p > PRM[k]->R)
		printf("p < 1 or > number of rows of PRM[%u]\n", k);
	else
	{
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
		printf("->\n");
		Temp = PRM[l];
		PRM[l] = ADD_MULT_ROWPR(p - 1, q - 1, PR[j], PRM[k]);
		FREEMATPR(Temp);
		printf("PRM[%u] = \n", l);
		PRINTMATPR(0, PRM[l]->R - 1, 0, PRM[l]->C - 1, PRM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_COLPR_()
{
	unsigned int j, k, l, p, q;
	MPMATPR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > PRM[k]->C)
		printf("q < 1 or > number of columns of PRM[%u]\n", k);
	else if (p < 1 || p > PRM[k]->C)
		printf("p < 1 or > number of columns of PRM[%u]\n", k);
	else
	{
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
		printf("->\n");
		Temp = PRM[l];
		PRM[l] = ADD_MULT_COLPR(p - 1, q - 1, PR[j], PRM[k]);
		FREEMATPR(Temp);
		printf("PRM[%u] = \n", l);
		PRINTMATPR(0, PRM[l]->R - 1, 0, PRM[l]->C - 1, PRM[l]);
	}
	GetReturn();
	return;
}

void OPS_PR()
{
	int GoOnFlag = 1;
        char c;

	while (GoOnFlag)
	{
		c = drawmenu(13);
		switch (c)
		{
		case 'i':
			SWAP_ROWSPR_();
			break;
		case 'j':
			SWAP_COLSPR_();
			break;
		case 'm':
			SCALAR_ROWPR_();
			break;
		case 'n':
			SCALAR_COLPR_();
			break;
		case 'a':
			ADD_MULT_ROWPR_();
			break;
		case 'b':
			ADD_MULT_COLPR_();
			break;
		case 'x':
			INPUTR_();
			break;
		case 'q':
			FPRINT_PR(cPR);
			FPRINTMAT_PR(cPRM);
			GoOnFlag = 0;
			break;
		}
	} 
}

void IDENTITY_PR()
{
	unsigned int m, j;

	if (scanf11(&m, &j) == 0)
		return;
	if (m == 0)
		printf("m == 0\n");
	else
	{
		FREEMATPR(PRM[j]);
		PRM[j] = IDENTITYPR(m);
		printf("PRM[%u] = \n\n", j);
		PRINTMATPR(0, PRM[j]->R - 1, 0, PRM[j]->C - 1, PRM[j]); 
	}
	GetReturn();
	return;
}

void DIAG_PR()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else
	{
		printf("xI[%u]\n", RM[j]->R);
		printf("- RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		FREEMATPR(PRM[k]);
		PRM[k] = DIAGXPR(RM[j]);
		printf(" ->\n");
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
	}
	GetReturn();
	return;
}

void ADJ_PR()
{
	unsigned int j, k;
	POLYR A;
	MPMATPR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	if (PRM[j]->R != PRM[j]->C)
		printf("Matrix PRM[%u] is not square\n", j);
	else if (PRM[j]->R == 1)
		printf("PRM[%u] is 1 x 1\n", j);
	else
	{
		printf("adj of PRM[%u] = \n", j);
		PRINTMATPR(0, PRM[j]->R - 1, 0, PRM[j]->C - 1, PRM[j]);
		Temp = PRM[k];
		A = LEVERRIER_PR(PRM[j], &PRM[k]);
		DELETE_PR(A);
		FREEMATPR(Temp);
		printf("->\n");
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
	}
	GetReturn();
	return;
}

void DET_PR()
{
	unsigned int j, k;
	MPMATPR *adj;

	if (scanf02(&j, &k) == 0)
		return;
	if (PRM[j]->R != PRM[j]->C)
		printf("Matrix PRM[%u] is not square\n", j);
	else if (PRM[j]->R == 1)
		printf("PRM[%u] is 1 x 1\n", j);
	else
	{
		printf("det of PRM[%u] = \n", j);
		PRINTMATPR(0, PRM[j]->R - 1, 0, PRM[j]->C - 1, PRM[j]);
		DELETE_PR(PR[k]);
		PR[k] = LEVERRIER_PR(PRM[j], &adj);
		FREEMATPR(adj);
		printf("->\n");
		printf("PR[%u] = ", k);
		PRINTPR(PR[k]);
		printf("\n");
	}
	GetReturn();
	return;
}

void SMITH_PR()
{
	unsigned int i, j, k, l, p, q, r, z;
	POLYR *A;
	MPMATPR *Temp1, *Temp2;

	if (scanf03(&j, &k, &l) == 0)
		return;
	ZEROTESTPR(0, PRM[j], &p, &q);
	if (p == PRM[j]->R && q == PRM[j]->C)
		printf("PRM[%u] is a zeromatrix\n", j);
	else
	{
		printf("The invariant factors of PRM[%u] = \n", j);
		PRINTMATPR(0, PRM[j]->R - 1, 0, PRM[j]->C - 1, PRM[j]);
		z = (PRM[j]->R >= PRM[j]->C) ? PRM[j]->C : PRM[j]->R;
		Temp1 = PRM[l];
		Temp2 = PRM[k];
		A = SMITHPR(PRM[j], &PRM[k], &PRM[l], &r);
		printf("are\n\n");
		for (i = 0; i < r; i++)
		{
			printf("invariant factor d[%u] = ", i + 1);
			PRINTPR(A[i]);
			printf("\n");
			DELETE_PR(A[i]);
		}
		ffree((char *) A, z * sizeof(POLYR));
		FREEMATPR(Temp1);
		FREEMATPR(Temp2);
		GetReturn();
		printf("PRM[%u] = \n", k);
		PRINTMATPR(0, PRM[k]->R - 1, 0, PRM[k]->C - 1, PRM[k]);
		printf("\n");
		GetReturn();
		printf("PRM[%u] = \n", l);
		PRINTMATPR(0, PRM[l]->R - 1, 0, PRM[l]->C - 1, PRM[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void SMITH1A_PR()
{
	int z;
	unsigned int i, r, j, c = 0;
	POLYR *A;
	MPMATPR *M;

	if (scanf01(&j) == 0)
		return;
	printf("The invariant factors of RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	M = DIAGXPR(RM[j]);
	z = (M->R >= M->C) ? M->C : M->R;
	A = SMITH1PR(M, &r);
	FREEMATPR(M);
	printf("are\n\n");
	for (i = 0; i <= r - 1; i++)
	{
		if (A[i]->DEG > 0)
		{
			c++;
			printf("invariant factor d[%u] = ", c);
			PRINTPR(A[i]);
			printf("\n");
		}
		DELETE_PR(A[i]);
	}
	ffree((char *) A, z * sizeof(POLYR));
	GetReturn();
	return;
}

void MATRIX_ARITH_PR()
{
	char c;
	int GoOnFlag;
	GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(12);
		switch (c)
		{
			case 'o':
				OPS_PR();
				break;
			case 'i':
				IDENTITY_PR();
				break;
			case 'e':
				DIAG_PR();
				break;
			case 'a':
				ADJ_PR();
				break;
			case 'd':
				DET_PR();
				break;
			case 'f':
				SMITH_PR();
				break;
			case 'F':
				SMITH1A_PR();
				break;
			case 'x':
				INPUTR_();
				break;
			case 'p':
				PRINTR_();
				break;
			case 'q':
				FPRINT_R(cR);
				FPRINTMAT_R(cRM);
				FPRINT_PR(cPR);
				FPRINTMAT_PR(cPRM);
				GoOnFlag = 0;
				break;
		}
	} 
}
