/* cm_RM1.c */

/* rational matrix routines used in cmR.c */

#include <stdio.h>
#include "integer.h"
#include "fun.h"

extern MPMATR *RM[];
extern POLYR PR[];
extern MPR *R[];

extern char cR[];
extern char cRM[];

void ADDMAT_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->R != RM[k]->R || RM[j]->C != RM[k]->C)
		printf("matrices RM[%u] and RM[%u] have incompatible sizes\n", j, k);
	else
	{
		printf("RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("+ RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		Temp = RM[l];
		RM[l] = ADDMATR(RM[j], RM[k]);
		FREEMATR(Temp);
		printf("->\n");
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void SUBMAT_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->R != RM[k]->R || RM[j]->C != RM[k]->C)
		printf("matrices RM[%u] and RM[%u] have incompatible sizes\n", j, k);
	else
	{
		printf("RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("- RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		Temp = RM[l];
		RM[l] = SUBMATR(RM[j], RM[k]);
		FREEMATR(Temp);
		printf("->\n");
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void SCALARMAT_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("R[%u] = ", j);
	PRINTR(R[j]);
	printf("\ntimes\n");
	printf("RM[%u] = \n", k);
	PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	Temp = RM[l];
	RM[l] = SCALARMATR(RM[k], R[j]);
	FREEMATR(Temp);
	printf("->\n");
	printf("RM[%u] = \n", l);
	PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	GetReturn();
	return;
}

void TRANSPOSE_R()
{
	unsigned int j, k;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("The transpose of RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	Temp = RM[k];
	RM[k] = TRANSPOSER(RM[j]);
	FREEMATR(Temp);
	printf("->\n");
	printf("RM[%u] = \n", k);
	PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	GetReturn();
	return;
}

void POWERMAT_R()
{
	unsigned int j, k, n;
	MPMATR *Temp;

	if (scanf12(&n, &j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else
	{
		printf("The power %u of RM[%u] = \n", n, j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		Temp = RM[k];
		RM[k] = POWERMATR(RM[j], n);
		FREEMATR(Temp);
		printf("->\n");
		printf("RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void DIAG_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else
	{
		printf("RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("- R[%u] ( = ", k);
		PRINTR(R[k]);
		printf(") * I[%u]\n", RM[j]->R);
		Temp = RM[l];
		RM[l] = DIAGR(RM[j], R[k]);
		FREEMATR(Temp);
		printf(" ->\n");
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void MULTMAT_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->C != RM[k]->R)
		printf("matrices RM[%u] and RM[%u] have incompatible sizes\n", j, k);
	else
	{
		printf("RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("* RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		Temp = RM[l];
		RM[l] = MULTMATR(RM[j], RM[k]);
		FREEMATR(Temp);
		printf("->\n");
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void MINUSMAT_R()
{
	unsigned int j, k;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("- RM[%d] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	Temp = RM[k];
	RM[k] = MINUSMATR(RM[j]);
	FREEMATR(Temp);
	printf("->\n");
	printf("RM[%d] = \n", k);
	PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	GetReturn();
	return;
}

void VALMAT_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("matrix RM[%u] is not square\n", j);
	else
	{
		printf("PR[%u] = ", j);
		PRINTPR(PR[j]);
		printf("\nevaluated at\nRM[%u] =\n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		Temp = RM[l];
		RM[l] = VALMATR(PR[j], RM[k]);
		FREEMATR(Temp);
		printf("\n->\nRM[%u] =\n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void MATRIX_ARITH_R()
{
	char c;
	int GoOnFlag = 1;

	while (GoOnFlag)
	{
		c = drawmenu(7);
		switch (c)
		{
		case 'a':
			ADDMAT_R();
			break;
		case 's':
			SUBMAT_R();
			break;
		case 'f':
			SCALARMAT_R();
			break;
		case '*':
			TRANSPOSE_R();
			break;
		case 'e':
			POWERMAT_R();
			break;
		case 't':
			MULTMAT_R();
			break;
		case 'm':
			MINUSMAT_R();
			break;
		case 'z':
			DIAG_R();
			break;
		case 'v':
			VALMAT_R();
			break;
		case 'p':
			PRINTR_();
			break;
		case 'x':
			INPUTR_();
			break;
		case 'q':
			FPRINT_R(cR);
			FPRINTMAT_R(cRM);
			GoOnFlag = 0;
			break;
		}
	}
}

void JOIN_COLUMNS_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->R != RM[k]->R)
		printf("matrices RM[%u] and RM[%u] have row numbers\n", j, k);
	else
	{
		printf("column-join RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("to RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		Temp = RM[l];
		RM[l] = JCOLSMATR(RM[j], RM[k]);
		FREEMATR(Temp);
		printf("->\n");
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void JOIN_ROWS_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->C != RM[k]->C)
		printf("matrices RM[%u] and RM[%u] have column numbers\n", j, k);
	else
	{
		printf("row-join RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("to RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		Temp = RM[l];
		RM[l] = JROWSMATR(RM[j], RM[k]);
		FREEMATR(Temp);
		printf("->\n");
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void JCOLSIDENTITY_R()
{
	unsigned int j, k;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("join RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	printf("to I[%u]\n", RM[j]->R);
	Temp = RM[k];
	RM[k] = JCOLSIDENTITYR(RM[j]);
	FREEMATR(Temp);
	printf("->\n");
	printf("RM[%u] = \n", k);
	PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	GetReturn();
	return;
}

void KRONECKER_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("RM[%d] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	printf("KRONECKER RM[%d] = \n", k);
	PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	Temp = RM[l];
	RM[l] = KRONECKERR(RM[j], RM[k]);
	FREEMATR(Temp);
	printf("->\n");
	printf("RM[%d] = \n", l);
	PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	GetReturn();
	return;
}

void DIRECT_SUM_R()
{
	unsigned int j, k, l;
	MPMATR *Temp;

	if (scanf03(&j, &k, &l) == 0)
		return;
	printf("RM[%d] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	printf("DIRECT_SUM RM[%d] = \n", k);
	PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	Temp = RM[l];
	RM[l] = DIRECT_SUMR(RM[j], RM[k]);
	FREEMATR(Temp);
	printf("->\n");
	printf("RM[%d] = \n", l);
	PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	GetReturn();
	return;
}
 
void UNWRAPMAT_R()
{
	unsigned int j, k;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("unwrap RM[%d] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	Temp = RM[k];
	RM[k] = UNWRAPMATR(RM[j]);
	FREEMATR(Temp);
	printf("done\n");
	GetReturn();
	return;
}

void JOINMAT_R()
{
	char c;
	int GoOnFlag = 1;

	while (GoOnFlag)
	{
		c = drawmenu(8);
		switch (c)
		{
		case 'c':
			JOIN_COLUMNS_R();
			break;
		case 'r':
			JOIN_ROWS_R();
			break;
		case 'i':
			JCOLSIDENTITY_R();
			break;
		case 'k':
			KRONECKER_R();
			break;
		case 'd':
			DIRECT_SUM_R();
			break;
		case 'u':
			UNWRAPMAT_R();
			break;
		case 'q':
			FPRINTMAT_R(cRM);
			GoOnFlag = 0;
			break;
		}	
	}
}

void SWAP_ROWSR_()
{
	unsigned int j, k, p, q;
	MPMATR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > RM[j]->R)
		printf("p < 1 or > number of rows of RM[%u]\n", j);
	else if (q < 1 || q > RM[j]->R)
		printf("q < 1 or > number of rows of RM[%u]\n", j);
	else
	{
		printf("RM[%d] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("->\n");
		Temp = RM[k];
		RM[k] = SWAP_ROWSR(p - 1, q - 1, RM[j]);
		FREEMATR(Temp);
		printf("RM[%d] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void SWAP_COLSR_()
{
	unsigned int j, k, p, q;
	MPMATR *Temp;

	if (scanf22(&p, &q, &j, &k) == 0)
		return;
	if (p < 1 || p > RM[j]->C)
		printf("p < 1 or > number of columns of RM[%u]\n", j);
	else if (q < 1 || q > RM[j]->C)
		printf("q < 1 or > number of columns of RM[%u]\n", j);
	else
	{
		printf("RM[%d] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("->\n");
		Temp = RM[k];
		RM[k] = SWAP_COLSR(p - 1, q - 1, RM[j]);
		FREEMATR(Temp);
		printf("RM[%d] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void SCALAR_ROWR_()
{
	unsigned int j, k, l, p;
	MPMATR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > RM[k]->R)
		printf("p < 1 or > number of rows of RM[%u]\n", k);
	else
	{
		printf("RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		printf("->\n");
		Temp = RM[l];
		RM[l] = SCALAR_ROWR(p - 1, R[j], RM[k]);
		FREEMATR(Temp);
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void SCALAR_COLR_()
{
	unsigned int j, k, l, p;
	MPMATR *Temp;

	if (scanf0112(&j, &p, &k, &l) == 0)
		return;
	if (p < 1 || p > RM[k]->C)
		printf("p < 1 or > number of columns of RM[%u]\n", k);
	else
	{
		printf("RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		printf("->\n");
		Temp = RM[l];
		RM[l] = SCALAR_COLR(p - 1, R[j], RM[k]);
		FREEMATR(Temp);
		printf("RM[%u] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_ROWR_()
{
	unsigned int j, k, l, p, q;
	MPMATR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > RM[k]->R)
		printf("q < 1 or > number of rows of RM[%u]\n", k);
	else if (p < 1 || p > RM[k]->R)
		printf("p < 1 or > number of rows of RM[%u]\n", k);
	else
	{
		printf("RM[%d] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		printf("->\n");
		Temp = RM[l];
		RM[l] = ADD_MULT_ROWR(p - 1, q - 1, R[j], RM[k]);
		FREEMATR(Temp);
		printf("RM[%d] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void ADD_MULT_COLR_()
{
	unsigned int j, k, l, p, q;
	MPMATR *Temp;

	if (scanf0122(&j, &p, &q, &k, &l) == 0)
		return;
	if (q < 1 || q > RM[k]->C)
		printf("q < 1 or > number of columns of RM[%u]\n", k);
	else if (p < 1 || p > RM[k]->C)
		printf("p < 1 or > number of columns of RM[%u]\n", k);
	else
	{
		printf("RM[%d] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		printf("->\n");
		Temp = RM[l];
		RM[l] = ADD_MULT_COLR(p - 1, q - 1, R[j], RM[k]);
		FREEMATR(Temp);
		printf("RM[%d] = \n", l);
		PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
	}
	GetReturn();
	return;
}

void OPS_R()
{
	int GoOnFlag = 1;
        char c;

	while (GoOnFlag)
	{
		c = drawmenu(9);
		switch (c)
		{
		case 'i':
			SWAP_ROWSR_();
			break;
		case 'j':
			SWAP_COLSR_();
			break;
		case 'm':
			SCALAR_ROWR_();
			break;
		case 'n':
			SCALAR_COLR_();
			break;
		case 'a':
			ADD_MULT_ROWR_();
			break;
		case 'b':
			ADD_MULT_COLR_();
			break;
		case 'x':
			INPUTR_();
			break;
		case 'q':
			FPRINTMAT_R(cRM);
			GoOnFlag = 0;
			break;
		}
	} 
}

void ExtractR_()
{
	char c;
	int GoOnFlag = 1;
	while (GoOnFlag)
	{
		c = drawmenu(10);
		switch (c)
		{
		case 'r':
			ExtractRow_R();
			break;
		case 'c':
			ExtractCol_R();
			break;
		case 'q':
			FPRINTMAT_R(cRM);
			GoOnFlag = 0;
			break;
		}
	}
}

void ExtractRow_R()
{
	unsigned int j, k, q;
	MPMATR *Temp;

	if (scanf12(&q, &j, &k) == 0)
		return;
	if (q < 1 || q > RM[j]->R)
		printf("q < 1 or > number of rows of RM[%u]\n", j);
	else
	{
		Temp = RM[k];
		RM[k] = ROWVECTORR(RM[j], q - 1);
		FREEMATR(Temp);
		printf("%u-th row vector of RM[%d] =\n", q, j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("->\nRM[%d] =\n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void ExtractCol_R()
{
	unsigned int j, k, q;
	MPMATR *Temp;

	if (scanf12(&q, &j, &k) == 0)
		return;
	if (q < 1 || q > RM[j]->C)
		printf("q < 1 or > number of columns of RM[%u]\n", j);
	else
	{
		Temp = RM[k];
		RM[k] = ColVectorR(RM[j], q - 1);
		FREEMATR(Temp);
		printf("%u-th column vector of RM[%d] =\n", q, j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("->\nRM[%d] =\n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}
