/* cm_RM2.c */

/* matrix routines used in cmR.c */

#include <stdio.h>
#include <stdlib.h>
#include "integer.h"
#include "fun.h"

extern MPMATR *RM[];
extern MPR *R[];
extern POLYR PR[];

extern char cR[];
extern char cRM[];
extern char cPRM[];
extern char cPR[];

void CHAR_POLY_R()
{
	unsigned int j, k;
	MPMATR *adj;
	MPR *det;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else
	{
		DELETE_PR(PR[k]);
		printf("the characteristic polynomial of RM[%u] = \n\n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("is PR[%u] = ", k);
		PR[k] = LEVERRIER_R(RM[j], &adj, &det);
		PRINTPR(PR[k]);
		printf("\n");
		FREEMATR(adj);
		FREEMPR(det);
	}
	GetReturn();
	return;
}

void MINIMUM_POLY_R()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else
	{
		DELETE_PR(PR[k]);
		printf("the minimum polynomial of RM[%u] = \n\n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("is PR[%u] = ", k);
		PR[k] = MINIMUM_POLYR(RM[j]);
		PRINTPR(PR[k]);
		printf("\n");
	}
	GetReturn();
	return;
}

void ADJ_R()
{
	unsigned int j, k;
	MPR *det;
	POLYR A;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else
	{
		printf("adj of RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		Temp = RM[k];
		A = LEVERRIER_R(RM[j], &RM[k], &det);
		FREEMATR(Temp);
		FREEMPR(det);
		DELETE_PR(A);
		printf("->\n");
		printf("RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void DET_R()
{
	unsigned int j, k;
	MPMATR *adj;
	POLYR A;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else
	{
	printf("det of RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	FREEMPR(R[k]);
	A = LEVERRIER_R(RM[j], &adj, &R[k]);
	DELETE_PR(A);
	FREEMATR(adj);
	printf("->\n");
	printf("R[%u] = ", k);
	PRINTR(R[k]);
	printf("\n");
	}
	GetReturn();
	return;
}

void INVERSE_MAT_R()
{
	unsigned int j, k;
	MPMATR *N;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else
	{
		printf("inverse of RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		N = INVERSEMATR(RM[j]);
		if (N == NULL)
			printf("does not exist.\n");
		else
		{
			FREEMATR(RM[k]);
			RM[k] = N;
			printf("->\n");
			printf("RM[%u] = \n", k);
			PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		}
	}
	GetReturn();
	return;
}

void TRANSFORM_MAT_R()
{
	unsigned int j, k, l;
	MPMATR *Temp1, *Temp2, *N;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[k]->C != RM[k]->R)
		printf("matrix RM[%u] is not square\n", k);
	else if (RM[j]->C != RM[j]->R)
		printf("matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else if (RM[k]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", k);
	else if (RM[j]->R != RM[k]->R)
		printf("matrices RM[%u] and RM[%u] have different sizes\n", j, k);
	else
	{
		N = INVERSEMATR(RM[j]);
		if (N == NULL)
			printf("RM[%u] inverse does not exist.\n", j);
		else
		{
			printf("The RM[%u] transform of RM[%u] -> \n", j, k);
			Temp1 = MULTMATR(N, RM[k]);
			Temp2 = RM[l];
			RM[l] = MULTMATR(Temp1, RM[j]);
			FREEMATR(Temp1);
			FREEMATR(Temp2);
			FREEMATR(N);
			printf("RM[%u] = \n", l);
			PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
		}
	}
	GetReturn();
	return;
}

void SOLVE_R()
{
	unsigned int j;

	if (scanf01(&j) == 0)
		return;
	printf("Solving the system with augmented matrix RM[%u] =  \n\n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	printf("\n");
	EQUATIONSR(RM[j]);
	GetReturn();
	return;
}

void ROW_REDUCE_R()
{
	unsigned int j, k, r, *D;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	printf("The reduced row-echelon form of RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	Temp = RM[k];
	RM[k] = GAUSS_JORDANR(RM[j], &r, &D);
	FREEMATR(Temp);
	printf("->\n");
	printf("RM[%u] = \n", k);
	PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	ffree((char *)D, RM[j]->C * sizeof(unsigned int));
	printf("rank = %u\n", r);
	GetReturn();
	return;
}

void NULL_SPACE_R()
{
	unsigned int j, k;
	MPMATR *N;

	if (scanf02(&j, &k) == 0)
		return;
	N = NULL_SPACER(RM[j]);
	printf("null-space of RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	if (N == NULL)
		printf("= {0}\n");
	else
	{
		FREEMATR(RM[k]);
		RM[k] = N;
		printf("has basis consisting of the columns of the matrix RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void COLUMN_SPACE_R()
{
	unsigned int j, k;
	MPMATR *N;

	if (scanf02(&j, &k) == 0)
		return;
	N = COLUMN_SPACER(RM[j]);
	printf("Column-space of RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	if (N == NULL)
		printf("= {0}\n");
	else
	{
		FREEMATR(RM[k]);
		RM[k] = N;
		printf("has basis consisting of the columns of the matrix RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void MATALG_R()
{
	int GoOnFlag = 1;
	char c;
	while (GoOnFlag)
	{
		c = drawmenu(11);
		switch (c)
		{
		case 'c':
			CHAR_POLY_R();
			break;
		case 'm':
			MINIMUM_POLY_R();
			break;
		case 'a':
			ADJ_R();
			break;
		case 'd':
			DET_R();
			break;
		case 'i':
			INVERSE_MAT_R();
			break;
		case 'z':
			INVERSE_MAT_I();
			break;
		case 't':
			TRANSFORM_MAT_R();
			break;
		case 'l':
			SOLVE_R();
			break;
		case 'g':
			ROW_REDUCE_R();
			break;
		case 'n':
			NULL_SPACE_R();
			break;
		case 'b':
			COLUMN_SPACE_R();
			break;
		case 'e':
			CHOLESKY_R();
			break;
		case 'p':
			PRINTR_();
			break;
		case 'x':
			INPUTR_();
			break;
		case 'q':
			FPRINT_R(cR);
			FPRINTMAT_R(cRM);
			FPRINT_PR(cPR);
			FPRINTMAT_PR(cPRM);
			GoOnFlag = 0;
			break;
		}
	}
}

void INVERSE_MAT_I()
{
	unsigned int j, k, l, r, s=0, flag = 0;
	MPMATI *TempI, *N;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else if (!EQONEI(R[k]->D))
		printf("R[%u] is not an integer\n", k);
	else if ((R[k]->D)->S <= 0)
		printf("R[%u] is not positive\n", k);
	else if (EQONEI(R[k]->N))
		printf("R[%u] = 1\n", k);
	else
	{
		for (r = 0; r < RM[j]->R; r++)
		{
			if (flag == 0)
			{
			    for (s = 0; s < RM[j]->R; s++)
			    {
				    if (!EQONEI(elt(RM[j], r, s)->D))
				    {
					    flag = 1;
					    break;
				    }
			    }
			}
			else
				break;
		}
		if (flag)
			printf("element(%u,%u) is not an integer\n", r, s);
		else
		{
		    printf("inverse of RM[%u]  = \n", j);
		    PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		    printf("mod ");
	            PRINTR(R[k]);	
                    TempI = MATR_TO_MATI(RM[j]);
		    N = INVERSEMATI(TempI, R[k]->N);
		    if (N == NULL)
			    printf("does not exist.\n");
		    else
		    {
			    FREEMATR(RM[l]);
			    RM[l] = MATI_TO_MATR(N);
			    FREEMATI(N);
			    printf(" ->\n");
			    printf("RM[%u] = \n", l);
			    PRINTMATR(0, RM[l]->R - 1, 0, RM[l]->C - 1, RM[l]);
		    }
		    FREEMATI(TempI);
		}
	}
	GetReturn();
	return;
}

void CHOLESKY_R()
{
	unsigned int j, k;
	MPMATR *N;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R != RM[j]->C)
		printf("Matrix RM[%u] is not square\n", j);
	else if (RM[j]->R == 1)
		printf("Matrix RM[%u] is 1 x 1\n", j);
	else
	{
		printf("Cholesky decomposition of RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		N = CHOLESKYR(RM[j]);
		if (N == NULL)
			printf("does not exist.\n");
		else
		{
			FREEMATR(RM[k]);
			RM[k] = N;
			printf("->\n");
			printf("RM[%u] = \n", k);
			PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		}
	}
	GetReturn();
	return;
}
