/* cm_RM3.c */

/* dot product rational routines used in cmR.c */

#include <stdio.h>
#include "integer.h"
#include "fun.h"

extern MPMATR *RM[];
extern MPR *R[];

void DOTR_()
{
	unsigned int j, k, l;

	if (scanf03(&j, &k, &l) == 0)
		return;
	if (RM[j]->R > 1 || RM[k]->R > 1)
		printf("RM[%u] or RM[%u] is not a row vector\n\n", j, k);
	else if (RM[j]->C != RM[k]->C)
		printf("RM[%u] and RM[%u] have different dimensions\n\n", j, k);
	else
	{
		printf("RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf(".\n");
		printf("RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
		printf("->\n");
		FREEMPR(R[l]);
		R[l] = DOTR(RM[j], RM[k]);
		printf("R[%u] = ", l);
		PRINTR(R[l]);
		printf("\n");
	}
	GetReturn();
	return;
}

void GRAM_SCHMIDTR_()
{
	unsigned int j, k;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	if (ZEROTESTR(RM[j]))
		printf("matrix RM[%u] is zero\n\n", j);
	else
	{
		printf("RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("->\n");
		Temp = RM[k];
		RM[k] = GRAM_SCHMIDTR(RM[j]);
		FREEMATR(Temp);
		printf("RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void DOTLR_()
{
	unsigned int j, k;

	if (scanf02(&j, &k) == 0)
		return;
	printf("length-squared of RM[%u] = \n", j);
	PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
	printf("-> ");
	FREEMPR(R[k]);
	R[k] = DOTLR(RM[j]);
	printf("R[%u] = ", k);
	PRINTR(R[k]);
	printf("\n");
	GetReturn();
	return;
}

void CROSS_PRODR_()
{
	unsigned int j, k;
	MPMATR *Temp;

	if (scanf02(&j, &k) == 0)
		return;
	if (RM[j]->R == 1)
		printf("RM[%u] has one row\n", j);
	else if ((RM[j]->R + 1) != RM[j]->C)
		printf("no. of rows of RM[%u] != no. of columns - 1\n", j);
	else
	{
		printf("cross-product of rows of RM[%u] = \n", j);
		PRINTMATR(0, RM[j]->R - 1, 0, RM[j]->C - 1, RM[j]);
		printf("->\n");
		Temp = RM[k];
		RM[k] = CROSS_PRODR(RM[j]);
		FREEMATR(Temp);
		printf("RM[%u] = \n", k);
		PRINTMATR(0, RM[k]->R - 1, 0, RM[k]->C - 1, RM[k]);
	}
	GetReturn();
	return;
}

void DOT_R()
{
	int GoOnFlag = 1;
        char c;

	while (GoOnFlag)
	{
		c = drawmenu(27);
		clearscreen();
		switch (c)
		{
		case 'd':
			DOTR_();
			break;
		case 'g':
			GRAM_SCHMIDTR_();
			break;
		case 'l':
			DOTLR_();
			break;
		case 'c':
			CROSS_PRODR_();
			break;
		case 'v':
			ExtractR_();
			break;
		case 'p':
			PRINTR_();
			break;
		case 'x':
			INPUTR_();
			break;
		case 'q':
			GoOnFlag = 0;
		}
	} 
}
