/* cm_m.c */
/* modular arithmetic routines used in cmm.c.*/

#include <stdio.h>
#include "integer.h"
#include "fun.h"

void ADD_m()
{
	unsigned int j, k, l, m;

	if (scanf30(&j, &k, &m) == 0)
		return;
	l = ADDm(j, k, m);
	printf("%u + %u = %u (mod %u)\n", j, k, l, m);
	GetReturn();
	return;
}

void SUB_m()
{
	unsigned int j, k, l, m;

	if (scanf30(&j, &k, &m) == 0)
		return;
	l = SUBm(j, k, m);
	printf("%u - %u = %u (mod %u)\n", j, k, l, m);
	GetReturn();
	return;
}

void MULT_m()
{
	unsigned int j, k, l, m;

	if (scanf30(&j, &k, &m) == 0)
		return;
	l = MULTm(j, k, m);
	printf("%u * %u = %u (mod %u)\n", j, k, l, m);
	GetReturn();
	return;
}

void POWERm_m()
{
	unsigned int n, j, k, m;

	if (scanf30(&n, &j, &m) == 0)
		return;
	k = POWER_m(j, n, m);
	printf("The %u-th power of %u = %u (mod %u)\n", n, j, k, m);
	GetReturn();
	return;
}

void RATIO_m()
{
	unsigned int g, j, k, l, m;

	if (scanf30(&j, &k, &m) == 0)
		return;
	g = GCDm(k, m);
	if (g > 1)
	{
		printf("GCD(%u, %u) = %u > 1 and so %u / %u (mod %u) does not exist!\n", k, m, g, j, k, m);
	}
	else
	{
		l = DIVm(j, k, m);
		printf("%u / %u = %u (mod %u)\n", j, k, l, m);
	}
	GetReturn();
	return;
}

void INVERSE_m()
{
	unsigned int g, j, k, m;

	if (scanf20(&j, &m) == 0)
		return;
	g = GCDm(j, m);
	if (g > 1)
	{
		printf("GCD(%u, %u) = %u > 1 and so 1 / %u (mod %u) does not exist!\n", j, m, g, j, m);
	}
	else
	{
		k = INVERSEm(j, m);
		printf("The inverse of %u (mod %u) = %u\n", j, m, k);
	}
	GetReturn();
	return;
}
