/* program: cmm.c */

#include <stdio.h>
#include <stdlib.h>
#ifndef _WIN32
#include "cmat.h"
#endif
#include "integer.h"
#include "fun.h"
#include "primes.h"

POLYm Pm[M0];
MPMATm *mM[M0];
MPMATPm *PmM[M0];

unsigned int VERSION=3;
char cPm[20], cmM[20], cPmM[20];
extern long int nettbytes;

int main()
{
#ifndef _WIN32
	readrc();
#endif
	INITMPIBANK();
#ifdef _WIN32
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("\t\t\tCMATM: VERSION 2.1: 4th July 2010\n");
	printf("\n\n");
	printf("\tAuthor:Dr.K.R. MATTHEWS\n\n\n\n");
	printf("\tBRISBANE, AUSTRALIA\n\n\n\n");
	printf("\thttp://www.numbertheory.org/keith.html\n\n\n\n");
	printf("\n\n\n\n");
	GetReturn();
#endif
	menuinit("menum.dat");
	CAL_m();
	menuend();
	exit (0);
}

void STARTUP_m()
{
	unsigned int i;
	FILE *fp;

	strcpy(cPm,"cPm");
	strcpy(cmM,"cmM");
	strcpy(cPmM,"cPmM");
	if ((fp = fopen(cPm, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			Pm[i] = NULL;
		FPRINT_Pm(cPm);
	}
	else
		fclose(fp);
	if ((fp = fopen(cmM, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			mM[i] = ZEROMNm(1, 1);
		FPRINTMAT_m(cmM);
	}
	else
		fclose(fp);
	if ((fp = fopen(cPmM, "r")) == NULL)
	{
		for (i = 0; i < M0; i++)
			PmM[i] = ZEROMNPm(1, 1);
		FPRINTMAT_Pm(cPmM);
	}
	else
		fclose(fp);
	FINPUT_Pm(cPm);
	FINPUTMAT_m(cmM, 0);
	FINPUTMAT_Pm(cPmM);
}

void FINISH_m()
{
	unsigned int i;

	for (i = 0; i < M0; i++)
	{
		FREEMATm(mM[i]);
		FREEMATPm(PmM[i]);
                DELETE_Pm(Pm[i]);
	}
	FREEMPIBANK();
#ifdef DEBUG
	printf("after cmatm nettbytes = %ld\n", nettbytes);
#endif
	GetReturn();
	return;
}

void CAL_m()
{
	int GoOnFlag = 1, GoOnFlag1, answer; 
	char c, cmd[50];

	STARTUP_m();
	while (GoOnFlag)
	{
		c = drawmenu(1);
		switch (c)
		{
		case 'i':
				clearscreen();
#ifdef _WIN32
				sprintf(cmd, "type info.dat | more");
				system(cmd);
#else
				sprintf(cmd, "%s %s/info.dat",PAGER,DATPATH);
				system(cmd);
#endif
			break;
		case 'x':
			INPUTm_();
			break;
		case 'L':
			LPRINTm_();
			break;
		case 'c':
			GoOnFlag1 = 1;
			while (GoOnFlag1)
			{
				c = drawmenu(2);
				switch (c)
				{
				case 'n':
					NumberCalcm();
					break;
				case 'p':
					PolyCalcm();
					break;
				case 'm':
					MatCalcm();
					break;
				case 'q':
					GoOnFlag1 = 0;
					break;
				}
			}
			break;
		case 'p':
			PRINTm_();
			break;
		case 'q':
			clearscreen();
			printf("y : save calculations\n");
			printf("n : do not save calculations\n\n");
			answer = GetYN();
			clearscreen();
			if (answer)
			{
				FPRINTMAT_m(cmM);
				FPRINT_Pm(cPm);
				FPRINTMAT_Pm(cPmM);
			}
			else
			{
				remove(cmM);
				remove(cPm);
				remove(cPmM);
			}
			printf("Exiting modular calculator\n");
			FINISH_m();
			GoOnFlag = 0;
			break;
		}
	}
}

void NumberCalcm()
{
	int GoOnFlag = 1;
	char c;
	while (GoOnFlag)
	{
		c = drawmenu(3);
		switch (c)
		{
		case 'a':
			ADD_m();
			break;
		case 's':
			SUB_m();
			break;
		case 't':
			MULT_m();
			break;
		case 'e':
			POWERm_m();
			break;
		case 'r':
			RATIO_m();
			break;
		case 'i':
			INVERSE_m();
			break;
		case 'q':
			GoOnFlag = 0;
			break;
		}
	}
}

void PolyCalcm()
{
	int GoOnFlag = 1;
	char c;

	while (GoOnFlag)
	{
		c = drawmenu(4);
		switch (c)
		{
			case 'a':
				ADD_Pm();
				break;
			case 's':
				SUB_Pm();
				break;
			case 't':
				MULT_Pm();
				break;
			case 'e':
				POWER_Pm();
				break;
			case 'v':
				VAL_Pm();
				break;
			case 'd':
				DERIV_Pm();
				break;
			case 'f':
				SCALAR_Pm();
				break;
			case 'r':
				DIV_Pm();
				break;
			case 'i':
				MOD_Pm();
				break;
			case 'g':
				GCD_Pm();
				break;
			case 'G':
				EUCLID_Pm();
				break;
			case 'L':
				EUCLIDS_Pm();
				break;
			case 'z':
				FactorCalcm();
				break;
			case 'x':
				INPUTm_();
				break;
			case 'p':
				PRINT_Pm();
				break;
			case 'q':
				GoOnFlag = 0;
				FPRINT_Pm(cPm);
				break;
		}
	}
}

void MatCalcm()
{
	int GoOnFlag = 1;
	char c;
	while (GoOnFlag)
	{
		c = drawmenu(5);
		switch (c)
		{
		case 'm':
			MATRIX_ARITH_m();
			break;
		case 'j':
			JOINMAT_m();	
			break;
		case 'o':
			OPS_m();
			break;
		case 'v':
			Extractm_();
			break;
		case 'c':
			MATALG_m();
			break;
		case 's':
			MATRIX_ARITH_Pm();
			break;
		case 'p':
			PRINTm_();
			break;
		case 'L':
			LPRINTm_();
			break;
		case 'x':
			INPUTm_();
			break;
		case 'q':
			GoOnFlag = 0;
			break;
		}
	}
}

void FactorCalcm()
{
	int GoOnFlag = 1;
	char c;

	while (GoOnFlag)
	{
		c = drawmenu(6);
		switch (c)
		{
			case 'c':
				CYCLOTOMIC_Pm();
				break;
			case 'b':
				BERLEKAMP_Pm();
				break;
			case 'z':
				SQUAREFREE_Pm();
				break;
			case 'w':
				FACTORS_Pm();
				break;
			case 'e':
				POWER0_Pm();
				break;
			case 'i':
				IRR_Pm();
				break;
			case 'x':
				INPUTm_();
				break;
			case 'p':
				PRINT_Pm();
				break;
			case 'q':
				GoOnFlag = 0;
				FPRINT_Pm(cPm);
				break;
		}
	}
}
