/* i7I.c */

#include <stdio.h>
#include "integer.h"
#include "fun.h"

MPMATI *ROWVECTORI(MPMATI *Mptr, USI i)
/*
 * returns the i-th row vector of *Mptr.
 */
{
	MPMATI *Temp;
	unsigned int j;
	
	Temp = BUILDMATI(1, Mptr->C);
	for (j = 0; j < Mptr->C; j++)
		elt(Temp, 0, j) = COPYI(elt(Mptr, i, j));
	return (Temp);
}

MPMATI *ColVectorI(MPMATI *Mptr, USI j)
/*
 * returns the j-th column vector of *Mptr.
 */
{
	MPMATI *Temp;
	unsigned i;
	Temp = BUILDMATI(Mptr->R, 1);
	for (i = 0; i < Mptr->R; i++)
		elt(Temp, i, 0) = COPYI(elt(Mptr, i, j));
	return Temp;
}

MPI *DOTI(MPMATI *Mptr, MPMATI *Nptr)
/*
 * *Aptr is the dot product of row vectors *Mptr and *Nptr.
 */
{
	unsigned int j;
	MPI *H, *Aptr, *TempI;
	
	Aptr = ZEROI();
	for (j = 0; j <= Mptr->C - 1; j++)
	{
		H = MULTI(elt(Mptr, 0, j), elt(Nptr, 0, j));
		TempI = Aptr;
		Aptr = ADDI(Aptr, H);
		FREEMPI(H);
		FREEMPI(TempI);
	}
	return (Aptr);
}

MPI *DOTCOLI(MPMATI *Mptr, MPMATI *Nptr)
/*
 * *Aptr is the dot product of column vectors *Mptr and *Nptr.
 */
{
	unsigned int i;
	MPI *H, *Aptr, *TempI;
	
	Aptr = ZEROI();
	for (i = 0; i <= Mptr->R - 1; i++)
	{
		H = MULTI(elt(Mptr, i, 0), elt(Nptr, i, 0));
		TempI = Aptr;
		Aptr = ADDI(Aptr, H);
		FREEMPI(H);
		FREEMPI(TempI);
	}
	return (Aptr);
}

MPI *DOTLI(MPMATI *Mptr)
/*
 * calculates the square of the length of *Mptr.
 */
{
	return (DOTI(Mptr, Mptr));
}
